%global commit0 daa4f1da5e34b274ca533766c5730696b1db7ca7
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

Name:    varnish-modules
Version: 0.9.2
Release: 0.1.20160924gitdaa4f1d%{?dist}
Summary: A collection of modules ("vmods") extending Varnish VCL

Group:   System Environment/Daemons
License: BSD
URL:     https://github.com/varnish/%{name}

Source0: https://download.varnish-software.com/varnish-modules/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# To make a tarball for building on older distros like el5:
#   git clone https://github.com/varnish/varnish-modules
#   cd varnish-modules
#   git checkout daa4f1d
#   sed -i 's/0\.9\.1/0.9.2/g;' configure.ac
#   sh bootstrap && ./configure && make && make dist


# Upstream issue 34: On el5, the of definition of TCP_CONGESTION is missing 
# from netinet/tcp.h Just snatch the value from linux/tcp.h here, as
# including linux/tcp.h leads to loads of redefines
Patch2:  varnish-modules-0.9.0-add_missing_TCP_CONGESTION_on_el5.patch

# Upstream issue 35, workspace_client is too small on 32bit
#Patch3:  varnish-modules-0.9.1-add_workspace_client_for_cookietest_on_32bit.patch

# Upstream issue 34, upstream commit 29be10d
#Patch4:  varnish-modules-0.9.1-fix_build_on_el5_git_29be10d.patch

Patch5: varnish-modules-0.9.2.fix_el5_Makefile.patch

BuildRequires: varnish-devel >= 5.0.0
BuildRequires: varnish >= 5.0.0
BuildRequires: pkgconfig
BuildRequires: make
BuildRequires: gcc
BuildRequires: python-docutils >= 0.6

Requires: varnishabi-5.0

%description
This is a collection of modules ("vmods") extending Varnish VCL used
for describing HTTP request/response policies with additional
capabilities. This collection contains the following vmods (previously
kept individually): cookie, vsthrottle, header, saintmode, softpurge,
tcp, var, xkey

%prep
%setup -q
%if 0%{?rhel} == 5
%patch2 -p0
%patch5
%endif
#%patch3
#%patch4 -p1

%build
export RST2MAN=rst2man
%if 0%{?rhel} == 5
export RST2MAN=rst2man.py
%endif

%configure --disable-static \
           --docdir=%{?_pkgdocdir}%{!?_pkgdocdir:%{_docdir}/%{name}-%{version}}
make %{?_smp_mflags}

# Build man pages
pushd docs
for i in vmod*.man.rst; do
  $RST2MAN -v "$i" "$(basename $i .man.rst).3";
  gzip "$(basename $i .man.rst).3";
done
popd

chmod 644 src/*.h
chmod 644 src/*.c
chmod 644 docs/*rst

%install
rm -rf %{buildroot}
make install DESTDIR=%{?buildroot} INSTALL="install -p"
find %{buildroot}/%{_libdir}/ -name '*.la' -exec rm -f {} ';'
rm %{buildroot}%{?_pkgdocdir}%{!?_pkgdocdir:%{_docdir}/%{name}-%{version}}/LICENSE
pushd docs
mkdir -p %{buildroot}%{_mandir}/man3
install -p -m 0644 *.3.gz %{buildroot}%{_mandir}/man3
popd

%check
make check


%files
%doc docs AUTHORS CHANGES.rst COPYING README.rst
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%license LICENSE
%else
%doc LICENSE
%endif
%{_libdir}/varnish/vmods/*
%{_mandir}/man3/*.3*


%changelog
* Sat Sep 24 2016 Ingvar Hagelund <ingvar@redpill-linpro.com> 0.9.2-0.1.20160924gitdaa4f1d
- Upstream git checkout with support for varnish-5.0
- el5 build fix

* Fri Aug 05 2016 Ingvar Hagelund <ingvar@redpill-linpro.com> 0.9.1-1
- New upstream release
- Build man pages, buildrequires python-docutils
- Added a patch for tests/cookie/08-overflow.vtc, upping workspace_client,
  the default is too small on 32bit
- Removed extra cflags for el5, fixed with patch from upstream
- Force readable docs and debug files, they tend to end up with mode 600

* Tue Apr 05 2016 Ingvar Hagelund <ingvar@redpill-linpro.com> 0.9.0-1
- First wrap for fedora
- Uses some old-style specfile components for el5 compatibility, including
  the usage of the BuildRoot header and cleaning the buildroot before install


